# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _cgivar.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $

function _cgivar(name,value,rdfmap,noauto) {

  rdfmap += 0			# cast into a number

  # turn multi-valued variables (most commonly "select multiple"
  # form elements) into rc(1) lists; for X-CSA- and CSA_RWA special
  # names retain only the latest value.

  if (name=="0" || _CGIVAL[name]=="" || name ~ /^(X_CSA_|CSA_RWA$)/) {
     # set fixed map length for 'name'
     _CGILEN[name] = 1
     # map as scalar, unless it is the null case.
     if (_CGIVAL[name] == "") _RDFMAP[name] = rdfmap
     else _RDFMAP[name] = "0"
     _CGIVAL[name] = value
  }
  else {
     # update map length for 'name'
     _CGILEN[name]++

     # set a unique name if file, unless 'noauto' was specified.
     # the latter flag is to preserve file-name unchanged for
     # RwA attachments. Note that the "-" delimiter for auto-naming
     # has been intentionally set to a character that cannot appare
     # in an RwA attachment name received in a MIME multipart message.
     # Auto-increment is mainly used to represent inline b64 data as
     # pseudo-attachments in the <call> section of a CSA-RPC request.

     if (rdfmap == 1 && !noauto) {
	sub(/\.tmp$/,"",value)
	value = value "-" _CGILEN[name] ".tmp"
     }

     _CGIVAL[name] = _CGIVAL[name] "\001" value
     _RDFMAP[name] = _RDFMAP[name] "\001" rdfmap
  }
}

