# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _isdate.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _isdate(string date, int month)
#
# Takes a date string in any format acceptable by date(1), and a month
# number, and checks whether the date value is a valid one, accounting
# for leap years, etc. Returns 0 on success, or _EINVAL otherwise.
# The month No. is needed to make the check.
# Note: this function requires the GNU version of date(1).
# =====================================================================

function _isdate( date, mnum,			month ) {

  _CMD = "exec date --date='" date "' +%m"
  _CMD | getline month
  close(_CMD)

  if (month/1 == 0) return _EINVAL
  if ((month/1) == (mnum/1)) return 0

  return _EINVAL
}

