# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _localdate.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _localdate(string iso_date, [boolean res])
#
# Takes a date string, in the ISO format "YYYY-mm-dd [HH:MM:SS]" and
# returns the equivalent dd/mm/yyyy or mm/dd/yyyy string, based on
# CSA_LANG. If the optional resolution argument is "1", then HH:MM:SS
# are also returned, if they were provided by the caller.
# =====================================================================

function _localdate(date,res,		local_date, token) {

  local_date = _strip(date)
  if (local_date == _NULL) return _NULL

  if (split(date, token, /[- :]/) < 3) return _NULL

  if (ENVIRON["CSA_LANG"] != "en_US") {			# Non-US
     local_date = token[3] "/" token[2] "/" token[1]
  }  else {						# US English
     local_date = token[2] "/" token[3] "/" token[1]
  }

  if (res)
     local_date = local_date " " token[4] ":" token[5] ":" token[6]

  return local_date
}

