# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _escreg.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# void _response(string name, string value, boolean noenc)
#
# Prepare encoded versions of the specified name/value pair, for use in
# response templates. If 'noenc' is non-zero, then 'value' is not
# encoded and is loaded verbatim into ENVIRON[]. This is mainly meant
# to allow for the inclusion of literal [X]HTML fragments.
# =====================================================================

function _response(name,value,noenc) {


  # Set URI-, URP-, ISO- and XML-PCDATA- encodings in ENVIRON[]. I
  # need to prepare all three encodings because this function is used
  # for both HTML and XML templates. Note that if the string is to be
  # included in an XML document and it must represent a URI, then the
  # the URI_ or URP_ versions, whichever applies, should be used. ISO_
  # encoding is practically only useful with HTML, and it is of no use
  # with XML.

  if (noenc == _O_NOENC) ENVIRON[name] = value
  else {
     ENVIRON["URI_" name] = _uriencode(value)
     ENVIRON["URP_" name] = _uriencode(value,1)
     ENVIRON["ISO_" name] = _isoencode(value)
     ENVIRON["XML_" name] = _xmlencode(value)
  }
}

